PROGRAM copoly
  USE mod_copoly
  USE ftn_getopt
  USE, INTRINSIC :: iso_fortran_env
  IMPLICIT NONE

!  TYPE(polynomial) :: s[*]
  CLASS(polynomial), ALLOCATABLE :: s[:]
  TYPE(event_type) :: ev[*]
  TYPE(opt_t) opt(2)
  INTEGER status[*]
  INTEGER :: i, me, q, src, dest
  
  me = this_image()

  ! determine image pair from command line
  opt = optinit( [ 'src ', 'dest' ], [ 'integer', 'integer' ] )
  CALL optarg(opt)
  CALL optval(opt(1), src)
  CALL optval(opt(2), dest)

  ! supply input data
  ! component stays unallocated on last image
  ALLOCATE(s[*])
  IF (me < num_images()) THEN
     s%f = [(real(i),i=1,me)]
  END IF
  SYNC ALL


  ! Put 
  IF (me == src) THEN
     q = dest
     status[q] = s%put(q)
     EVENT POST (ev[q]) 
  END IF

  IF (me == dest) THEN
     EVENT WAIT (ev)
     IF ( allocated(s%f) ) THEN
        WRITE(*,FMT='("Put from ",I0, " to ",I0," result: Status = ",I0," Value = ",*(F5.1))') src, dest, status, s%f
     ELSE
        WRITE(*,FMT='("Put from ",I0," to ",I0," result: Status = ",I0," Value = (unallocated) ")') src, dest, status
     END IF
  END IF

  SYNC ALL

  ! Get
  IF (me == src) THEN
     IF (me /= num_images()) s%f = [(real(i),i=1,me)]
     q = dest
     EVENT POST (ev[q])
  ELSE
     IF (allocated(s%f)) DEALLOCATE(s%f)
  END IF
  
  IF (me == dest) THEN
     EVENT WAIT (ev)
     q = src
     status = s%get(q)
     IF ( allocated(s%f) ) THEN
        WRITE(*,FMT='("Get from ",I0, " to ",I0," result: Status = ",I0," Value = ",*(F5.1))') src, dest, status, s%f
     ELSE
        WRITE(*,FMT='("Get from ",I0," to ",I0," result: Status = ",I0," Value = (unallocated) ")') src, dest, status
     END IF
  END IF
  
END PROGRAM copoly
