MODULE mod_copoly
  ! How to use type-bound procedures to handle "container" types
  IMPLICIT NONE

  PRIVATE
  INTEGER, PARAMETER, PUBLIC :: comm_success = 0, comm_fail = 1
  TYPE, PUBLIC :: polynomial
     REAL, ALLOCATABLE :: f(:)
   CONTAINS
     PROCEDURE :: get, put
  END TYPE polynomial
  
CONTAINS
  INTEGER FUNCTION put(this, img)
    CLASS(polynomial), INTENT(INOUT) :: this[*]
    INTEGER, INTENT(IN) :: img
    INTEGER :: rem_size, lb, ub
    IF ( .NOT. ( allocated( this[img]%f ) .AND. allocated( this%f) ) ) THEN
       put = comm_fail
       RETURN
    END IF
    rem_size = size( this[img]%f,1 )
    IF ( rem_size >= size( this%f ) ) THEN
       lb = lbound( this[img]%f,1 ); ub = lb + size( this%f,1 ) - 1
       this[img]%f(lb:ub) = this%f
       this[img]%f(ub+1:) = 0.0
       put = comm_success
    ELSE
       put = comm_fail
    END IF
  END FUNCTION put
  INTEGER FUNCTION get(this, img)
    CLASS(polynomial), INTENT(INOUT) :: this[*]
    INTEGER, INTENT(IN) :: img

    IF ( .NOT. allocated(this[img]%f) ) THEN
       get = comm_fail
    ELSE
       this%f = this[img]%f ! auto-allocation if needed
       get = comm_success
    END IF
  END FUNCTION get
END MODULE mod_copoly
